﻿Type=StaticCode
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private  NH As NativeHook
	Private mModule As Object
	Private TH As Thread									'ignore
	Private mFM As FloatingMenu
	Private CSU As CallSubUtils
End Sub
Sub initialize(Module As Object,FM As FloatingMenu)
	mModule = Module			'Parent module
	mFM = FM					'Need to access the Floating Menu Object so we can close it if it's not clicked on.
	CSU.Initialize				'CallSubUtils
	TH.Initialise("TH")			'Initialize a Thread Object so we can pass data to the Gui Thread
	NH.Initialize("NH", Me)     'Initializes and registers the NativeHook
    NH.startNativeKeyListener   'starts a NativeKeyListener
    NH.enableKillCode   		'Allows you to manually unregister by pressing Windows_Escape
    NH.EnableEventConsumption  	'Allows you to consume input events
	NH.startNativeMouseInputListener
End Sub

'Not working as expected, replaced with MousePressed and Released
'Sub NH_NativeMouseClicked(nme As NativeMouseEvent) As Boolean
'	Log(nme.MouseButton & " : X " & nme.X & " Y " & nme.Y)
'	If nme.MouseButton = 2 Then 
'		Log("Mouse Button 2 Clicked")
'		Return True
'	End If
'	Return False
'End Sub

'Sub to handle Mouse Pressed call from the Native hook
Sub NH_NativeMousePressed(nme As NativeMouseEvent) As Boolean
	
	If nme.MouseButton = 2 Then 
		'Mouse button 2 has been pressed
		TH.RunOnGuiThread("Mouse_Clicked",Array(nme,True))
		'Consume the event
		Return True
	End If

	Return False
End Sub

'Sub to handle Mouse Released call from the Native hook
Sub NH_NativeMouseReleased(nme As NativeMouseEvent) As Boolean

	If nme.MouseButton = 2 Then 
		'Mouse button 2 has been released
		TH.RunOnGuiThread("Mouse_Clicked",Array(nme,False))
		'Consume the event
		Return True
	End If

	'Need to delay this call as it can interfere with the callback from the Floating Menu if it runs too quickly
	CSU.CallSubPlus(Me,"THMFHide",250)
	
	'Do not consume the event
	Return False
End Sub

'
#Region 'Gui call Subs
'Need an intermediate sub as it is called from a seperate Thread
Sub Mouse_Clicked(nme As NativeMouseEvent, Pressed As Boolean)
	CallSub3(mModule,"Mouse2_Clicked",nme, Pressed)
End Sub

'Need an intermediate sub as it is called from a seperate Thread
Sub mFMHide As Boolean																	'ignore
	mFM.hide
	Return False
End Sub

'Need a second intermediate sub as it is called from a seperate Thread and delayed
Sub THMFHide																			'ignore
	TH.RunOnGuiThread("mFMHide",Null)
End Sub
'
#End Region
'

'Event fired whenever a key is pressed, regardless of what application is in focus
Sub NH_NativeKeyPressed(nke As NativeKeyEvent) As Boolean
    If NH.isCharacter(nke.keyCode) Then
        Log(nke.keyText & " Pressed")
		'Not needed for the mouse example
'        If nke.keyText=="F" Then Return True    'Consumes the event if the user pressed the "F" key
    End If
    Return False
End Sub

'Allow stopping listeners
Sub Stop
	NH.endNativeMouseInputListener
	NH.unregisterNativeHook
End Sub

'Event fired when the NativeHook is unregistered
'Sub needs to be here or an error is thrown by the library, it is used will depend on the application.
'This application only unregisters the listener when it closes so we don't need to do anything.
Sub NH_Unregistered
    Log("NativeHook unregistered")
'	ExitApplication
End Sub